var graphicGL = require("../graphicGL");

var SpritesGeometry = require("../geometry/Sprites");

var labelsGLSL = require("../shader/labels.glsl.js");

graphicGL.Shader.import(labelsGLSL);

var _default = graphicGL.Mesh.extend(function () {
  var geometry = new SpritesGeometry({
    dynamic: true
  });
  var material = new graphicGL.Material({
    shader: graphicGL.createShader('ecgl.labels'),
    transparent: true,
    depthMask: false
  });
  return {
    geometry: geometry,
    material: material,
    culling: false,
    castShadow: false,
    ignorePicking: true
  };
});

module.exports = _default;